program signaltest;

{$mode objfpc}{$H+}
{$define UseCThreads}

uses
	{$IFDEF UNIX}{$IFDEF UseCThreads}
	cthreads, cmem,
	{$ENDIF}{$ENDIF}
	Interfaces, // this includes the LCL widgetset
	Forms, Unit1,
	BaseUnix, SysUtils, Dialogs;

{$R *.res}

type
	unix_signal = cint;
	unix_signal_callback = procedure (signal: unix_signal); cdecl;
	punix_signal_callback = ^unix_signal_callback;

function assign_signal(signal: unix_signal; callback: punix_signal_callback): boolean;
var act: sigactionrec;
begin
	act.sa_handler := sigactionhandler(callback);
	fpsigemptyset(act.sa_mask);
	act.sa_flags := 0;
{$ifdef linux}
	act.sa_restorer := nil;
{$endif}
	result := fpsigaction(signal, @act, nil) <> 0;
end;

procedure sighnd(signal: cint); cdecl;
begin
	WriteLn('Got signal: ' + inttostr(signal));
	if (signal = SIGUSR1) then
	begin
		Form1.Show;
	end;
	if (signal in [SIGTERM, SIGINT, SIGQUIT, SIGHUP]) then
	begin
		Form1.Close;
	end;
end;

begin
	RequireDerivedFormResource:=True;
	Application.Scaled:=True;
	Application.Initialize;
	Application.CreateForm(TForm1, Form1);
	assign_signal(SIGTERM, punix_signal_callback(@sighnd));
	assign_signal(SIGINT, punix_signal_callback(@sighnd));
	assign_signal(SIGHUP, punix_signal_callback(@sighnd));
	assign_signal(SIGQUIT, punix_signal_callback(@sighnd));
	assign_signal(SIGUSR1, punix_signal_callback(@sighnd));
	Application.Run;
end.

