unit Unit1;

{$mode objfpc}{$H+}

interface

uses
	Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

	{ TForm1 }

 TForm1 = class(TForm)
		Button1: TButton;
		procedure Button1Click(Sender: TObject);
		procedure FormClose(Sender: TObject;
			var CloseAction: TCloseAction);
		procedure FormCreate(Sender: TObject);
		procedure FormShow(Sender: TObject);

	private

	public

	end;

	TThreadType1 = class(TThread)
		private
		protected
			procedure Execute; override;
		public
			Constructor Create;
	end;

	TThreadType2 = class(TThread)
		private
		protected
			procedure Execute; override;
		public
			Constructor Create;
	end;

var
	Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

var
	ThreadType1: TThreadType1;
	ThreadType2: TThreadType2;
	FirstShow: boolean;

constructor TThreadType1.Create;
begin
	inherited Create(false);
	FreeOnTerminate := False;
end;

procedure TThreadType1.Execute;
begin
	while (not Self.Terminated) do
	begin
		sleep(1000);
		WriteLn('Thread 1 is running...');
	end;
	WriteLn('Thread 1 has been terminated.');
end;

constructor TThreadType2.Create;
begin
	inherited Create(false);
	FreeOnTerminate := False;
end;

procedure TThreadType2.Execute;
begin
	while (not Self.Terminated) do
	begin
		sleep(1000);
		WriteLn('Thread 2 is running...');
	end;
	WriteLn('Thread 2 has been terminated.');
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
	Form1.Hide;
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
var i: integer;
begin
	WriteLn('Terminating Thread 1...');
	ThreadType1.Terminate;
	i := 0;
	while ((i < 10) and (not ThreadType1.Finished)) do
	begin
		inc(i);
		WriteLn('Waiting for Thread 1 to finish...');
		sleep(1000);
	end;

	if (ThreadType1.Finished) then
	begin
		WriteLn('Thread 1 has finished.');
	end
	else
	begin
		WriteLn('Thread 1 has timed out.');
	end;

	try
		ThreadType1.Free;
		WriteLn('Thread 1 has been freed.');
	except
		WriteLn('Thread 1 has crashed.');
	end;

	WriteLn('Terminating Thread 2...');
	ThreadType2.Terminate;
	i := 0;
	while ((i < 10) and (not ThreadType2.Finished)) do
	begin
		inc(i);
		WriteLn('Waiting for Thread 2 to finish...');
		sleep(1000);
	end;

	if (ThreadType2.Finished) then
	begin
		WriteLn('Thread 2 has finished.');
	end
	else
	begin
		WriteLn('Thread 2 has timed out.');
	end;

	try
		ThreadType2.Free;
		WriteLn('Thread 2 has been freed.');
	except
		WriteLn('Thread 2 has crashed.');
	end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
	FirstShow := true;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
	if (FirstShow) then
	begin
		ThreadType1 := TThreadType1.Create;
		ThreadType2 := TThreadType2.Create;
		FirstShow := false;
	end;
end;

end.

